;**********************************************************************
;
;  N80t@C  PC8001-mini œǂݍނ߂̃[_
;
;  (2020.06.29)
;
;  CMTt@CɂA imgt@CB
;
;  Ⴆ΁A
;  copy /b N80_loader.cmt + C[Wt@C.img CMTt@C.cmt
;
;
;  N80_loader.cmt ̖ɂ́A$F5, $F6, $F7̃}[J[O
;    ǉĂ܂B
;
;**********************************************************************

  ORG  06000H

  CALL 0BF3H             ; Motor ON and ready for input

SEARCH_MARKER:
  CALL 0C88H             ; Read 1byte from CMT and throw away
  CMP  F5H
  JR   Z,FOUND_F5
  JR   SEARCH_MARKER
FOUND_F5:
  CALL 0C88H             ; Read 1byte from CMT and throw away
  CMP  F6H
  JR   Z,FOUND_F6
  CMP  F5h
  JR   Z,FOUND_F5
  JR   SEARCH MARKER
FOUND_F6:
  CALL 0C88H             ; Read 1byte from CMT and throw away
  CMP  F7H
  JR   Z,FOUND_F7
  CMP  F5h
  JR   Z,FOUND_F5
  JR   SEARCH MARKER
FOUND_F7:

  LD   SP,8000H          ; Change Stack pointer
  LD   BC,7F40H          ; number of bytes to be read from CMT
  LD   HL,8000H          ; Start address of image

LOOP_C:
  CALL 0C88H             ; Read 1 bytes
  LD   (HL),A            ; Store read byte
  INC  HL                ; update address
  DEC  BC                ; decrement counter
  LD   A,B               ; Check counter reaches zero
  OR   C
  JR   NZ,LOOP_C         ; If not finish, repeat

  ;
  ; Restore screen mode
  ;
  LD   A,(0EA60H)        ; Color and console
  LD   B,A
  LD   A,(0EA61H)
  LD   C,A
  CALL 08F7H

  LD   A,(0EA62H)        ; Width setting
  LD   C,A
  LD   A,(0EA65H)
  LD   B,A
  CALL 093AH

  ;
  ; Jump to restore routine
  ;
  LD SP,(0FF3EH)
  JP 0FF3DH
